routes/web.php
<?php

use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function () {
    return view('welcome');
})->name('welcome');

Route::resource("genres", "App\Http\Controllers\GenreController");
Route::resource("authors", "App\Http\Controllers\AuthorController");
Route::resource("books", "App\Http\Controllers\BookController");

app/Models/Author.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class Author extends Model
{
    use HasFactory;

    protected $fillable = ["nombre", "apellidos", "nacionalidad", "fechaNacimiento"];

    public function books()
    {
        return $this->hasMany("App\Models\Book", "idAutor");
    }
}

app/Http/Controllers/AuthorController.php
<?php

namespace App\Http\Controllers;

use App\Models\Author;
use App\Http\Requests\StoreAuthorRequest;
use App\Http\Requests\UpdateAuthorRequest;

class AuthorController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        return view('authors.index', ['authors' => Author::get()]);
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        return view('authors.create');
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \App\Http\Requests\StoreAuthorRequest  $request
     * @return \Illuminate\Http\Response
     */
    public function store(StoreAuthorRequest $request)
    {
        $fields = $request->validate([
            'nombre' => 'required|string',
            'apellidos' => 'required|string',
            'nacionalidad' => 'required|string',
            'fechaNacimiento' => 'required|date',
        ]);

        Author::create($fields);
        return redirect()->route('authors.index');
    }

    /**
     * Display the specified resource.
     *
     * @param  \App\Models\Author  $author
     * @return \Illuminate\Http\Response
     */
    public function show(Author $author)
    {
        return view('authors.show', ['author' => $author]);
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  \App\Models\Author  $author
     * @return \Illuminate\Http\Response
     */
    public function edit(Author $author)
    {
        return view('authors.edit', ['author'=>$author]);
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \App\Http\Requests\UpdateAuthorRequest  $request
     * @param  \App\Models\Author  $author
     * @return \Illuminate\Http\Response
     */
    public function update(UpdateAuthorRequest $request, Author $author)
    {
        $fields = $request->validate([
            'nombre' => 'required|string',
            'apellidos' => 'required|string',
            'nacionalidad' => 'required|string',
            'fechaNacimiento' => 'required|date',
        ]);

        $author->update($fields);
        return redirect()->route('authors.index');
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  \App\Models\Author  $author
     * @return \Illuminate\Http\Response
     */
    public function destroy(Author $author)
    {
        $author->delete();
        return redirect()->route('authors.index');
    }
}

resources/views/authors/create.blade.php
@extends('layout')

@section('title', 'Agregar Autor')

@section('content')
    <div class="container">
        <div class="row titulo">
            <h1>Insertar Autor</h1>
        </div>
        <div class="row acciones mb-4">
            <a class="boton" href="{{ route('authors.index') }}">Regresar</a>
        </div>
        <div class="row formulario">
            <fieldset>
                <form action="{{ route('authors.store') }}" method="POST">
                    @csrf

                    <label for="nombre">Nombre</label>
                    <input type="text" name="nombre" required>

                    <label for="apellidos">Apellidos</label>
                    <input type="text" name="apellidos" required>

                    <label for="nacionalidad">Nacionalidad</label>
                    <input type="text" name="nacionalidad" required>

                    <label for="fechaNacimiento">Fecha de nacimiento</label>
                    <input type="date" name="fechaNacimiento" required>

                    <div class="acciones">
                        <input class="boton" type="submit" value="Guardar">
                    </div>
                </form>
            </fieldset>
        </div>
    </div>
@endsection

resources/views/authors/edit.blade.php
@extends('layout')

@section('title', 'Modificar Autor')

@section('content')
    <div class="container">
        <div class="row titulo">
            <h1>Modificar Autor</h1>
        </div>
        <div class="row acciones mb-4">
            <a class="boton" href="{{ route('authors.index') }}">Regresar</a>
        </div>
        <div class="row formulario">
            <fieldset>
                <form action="{{ route('authors.update', $author) }}" method="POST">
                    @csrf
                    @method('PATCH')

                    <label for="id">ID</label>
                    <input type="number" name="id" value="{{ $author->id }}" readonly>

                    <label for="nombre">Nombre</label>
                    <input type="text" name="nombre" value="{{ $author->nombre }}" required>

                    <label for="apellidos">Apellidos</label>
                    <input type="text" name="apellidos" value="{{ $author->apellidos }}" required>

                    <label for="nacionalidad">Nacionalidad</label>
                    <input type="text" name="nacionalidad" value="{{ $author->nacionalidad }}" required>

                    <label for="fechaNacimiento">Fecha de nacimiento</label>
                    <input type="date" name="fechaNacimiento" value="{{ $author->fechaNacimiento }}" required>

                    <div class="acciones">
                        <input class="boton" type="submit" value="Guardar">
                    </div>
                </form>
            </fieldset>
        </div>
    </div>
@endsection

resources/views/authors/index.blade.php
@extends('layout')

@section('title', 'Autores')

@section('content')
    <div class="container">
        <div class="row titulo">
            <h1>Autores</h1>
        </div>
        <div class="row acciones mb-4">
            <a class="boton me-2" href="{{ route('welcome') }}">Regresar</a>
            <a class="boton" href="{{ route('authors.create') }}">Agregar Autor</a>
        </div>
        <div class="row">
            @if(!$authors->isEmpty())
                <div class="container tabla">
                    <div class="row encabezado">
                        <div class="col-12 col-md-3 columna">ID</div>
                        <div class="col-12 col-md-3 columna">Nombre</div>
                        <div class="col-12 col-md-6 columna">Acciones</div>
                    </div>
                    @foreach($authors as $author)
                    <div class="row contenido">
                        <div class="col-12 col-md-3 columna">{{ $author->id }}</div>
                        <div class="col-12 col-md-3 columna">{{ $author->nombre }}</div>
                        <div class="col-12 col-md-6 acciones columna">
                            <a class="boton mostrar col" href="{{ route('authors.show', $author) }}">Mostrar</a>
                            <a class="boton editar col" href="{{ route('authors.edit', $author) }}">Editar</a>
                            <form class="col" action="{{ route('authors.destroy', $author) }}" method="POST">
                                @csrf
                                @method('DELETE')
                                <input class="boton eliminar" type="submit" value="Eliminar">
                            </form>
                        </div>
                    </div>
                    @endforeach
                </div>
            @else
                <div class="col">
                    No existen autores para mostrar
                </div>
            @endif
        </div>
    </div>
@endsection

resources/views/authors/show.blade.php
@extends('layout')

@section('title', 'Mostrar Autor')

@section('content')
    <div class="container">
        <div class="row titulo">
            <h1>{{ $author->nombre }}</h1>
        </div>
        <div class="row acciones">
            <a class="boton" href="{{ route('authors.index') }}">Regresar</a>
        </div>
        <div class="row contenido">
            <h2>Nombre: {{ $author->nombre }}</h2>
            <h2>Apellidos: {{ $author->apellidos }}</h2>
            <h2>Nacionalidad: {{ $author->nacionalidad }}</h2>
            <h2>Fecha de nacimiento: {{ $author->fechaNacimiento }}</h2>
        </div>
    </div>
@endsection